diff --git a/sys/cpu/x86_64/include/bus_dma.h b/sys/cpu/x86_64/include/bus_dma.h
index 4e5b133445..c99fbab336 100644
--- a/sys/cpu/x86_64/include/bus_dma.h
+++ b/sys/cpu/x86_64/include/bus_dma.h
@@ -57,33 +57,13 @@ typedef uint64_t bus_space_handle_t;
 /*
  * Map a region of device bus space into CPU virtual address space.
  */
-
-static __inline int bus_space_map(bus_space_tag_t t, bus_addr_t addr,
-				  bus_size_t size, int flags,
-				  bus_space_handle_t *bshp);
-
-static __inline int
-bus_space_map(bus_space_tag_t t __unused, bus_addr_t addr,
-	      bus_size_t size __unused, int flags __unused,
-	      bus_space_handle_t *bshp)
-{
-
-	*bshp = addr;
-	return (0);
-}
+int bus_space_map(bus_space_tag_t, bus_addr_t, bus_size_t, int,
+		  bus_space_handle_t *);
 
 /*
  * Unmap a region of device bus space.
  */
-
-static __inline void bus_space_unmap(bus_space_tag_t t, bus_space_handle_t bsh,
-				     bus_size_t size);
-
-static __inline void
-bus_space_unmap(bus_space_tag_t t __unused, bus_space_handle_t bsh __unused,
-		bus_size_t size __unused)
-{
-}
+void bus_space_unmap(bus_space_tag_t, bus_space_handle_t, bus_size_t);
 
 /*
  * Get a new handle for a subregion of an already-mapped area of bus space.
diff --git a/sys/dev/netif/re/if_re.c b/sys/dev/netif/re/if_re.c
index 60b5b983e7..901544a023 100644
--- a/sys/dev/netif/re/if_re.c
+++ b/sys/dev/netif/re/if_re.c
@@ -871,6 +871,7 @@ re_detach(device_t dev)
 		bus_release_resource(dev, sc->re_res_type, sc->re_res_rid,
 		    sc->re_res);
 	}
+	rtl_cmac_unmap(sc);
 
 	/* Free DMA stuffs */
 	re_freemem(dev);
diff --git a/sys/dev/netif/re/if_revar.h b/sys/dev/netif/re/if_revar.h
index 3de265e216..4d53630109 100644
--- a/sys/dev/netif/re/if_revar.h
+++ b/sys/dev/netif/re/if_revar.h
@@ -180,6 +180,17 @@ struct re_softc {
 	struct ifmedia		media;
 	u_int16_t		cur_page;
 	u_int8_t		re_unit;
+	u_int8_t		re_efuse_ver;
+	u_int16_t		re_sw_ram_code_ver;
+	u_int16_t		re_hw_ram_code_ver;
+	u_int8_t		RequiredSecLanDonglePatch;
+	u_int8_t		HwSuppDashVer;
+	u_int8_t		re_dash;
+	bus_space_handle_t	re_mapped_cmac_handle;	/* bus space tag */
+	bus_space_tag_t		re_mapped_cmac_tag;	/* bus space tag */
+	bus_space_handle_t	re_cmac_handle;		/* bus space handle */
+	bus_space_tag_t		re_cmac_tag;		/* bus space tag */
+	u_int8_t		HwPkgDet;
 };
 
 #define RE_C_HWIM		0x4	/* hardware interrupt moderation */
diff --git a/sys/dev/netif/re/re.c b/sys/dev/netif/re/re.c
index dfe6b3a706..16958e8335 100644
--- a/sys/dev/netif/re/re.c
+++ b/sys/dev/netif/re/re.c
@@ -42,7 +42,7 @@
 
 #ifndef __DragonFly__
 #include <sys/cdefs.h>
-__FBSDID("$FreeBSD: src/sys/dev/re/if_re.c,v 1.93 " __DATE__ " " __TIME__ "  wpaul Exp $");
+__FBSDID("$FreeBSD: src/sys/dev/re/if_re.c,v 1.94.01 " __DATE__ " " __TIME__ "  wpaul Exp $");
 
 /*
 * This driver also support Realtek 8139C+, 8110S/SB/SC, RTL8111B/C/CP/D and RTL8101E/8102E/8103E.
@@ -56,6 +56,7 @@ __FBSDID("$FreeBSD: src/sys/dev/re/if_re.c,v 1.93 " __DATE__ " " __TIME__ "  wpa
 #include <sys/kernel.h>
 #include <sys/socket.h>
 #include <sys/taskqueue.h>
+#include <sys/random.h>
 
 #include <net/if.h>
 #include <net/if_var.h>
@@ -184,11 +185,15 @@ static void MP_WritePhyOcpRegWord       __P((struct re_softc*, u_int16_t, u_int8
 static u_int16_t MP_ReadPhyOcpRegWord   __P((struct re_softc*, u_int16_t, u_int8_t));
 static void MP_WriteMcuAccessRegWord    __P((struct re_softc*, u_int16_t, u_int16_t));
 static u_int16_t MP_ReadMcuAccessRegWord  __P((struct re_softc*, u_int16_t));
+static void MP_WriteOtherFunPciEConfigSpace    __P((struct re_softc *, u_int8_t, u_int16_t, u_int32_t Regata));
+static u_int32_t MP_ReadOtherFunPciEConfigSpace   __P((struct re_softc *, u_int8_t, u_int16_t));
 static void MP_WritePciEConfigSpace     __P((struct re_softc*, u_int16_t, u_int32_t));
 static u_int32_t MP_ReadPciEConfigSpace __P((struct re_softc*, u_int16_t));
+#endif	/* !__DragonFly__ */
 
 static int re_check_dash  __P((struct re_softc *));
 
+#ifndef __DragonFly__
 static void re_driver_start             __P((struct re_softc*));
 static void re_driver_stop         	__P((struct re_softc*));
 
@@ -200,9 +205,9 @@ static void re_stop			__P((struct re_softc *));
 static void re_setwol			__P((struct re_softc *));
 #endif	/* !__DragonFly__ */
 static void re_clrwol			__P((struct re_softc *));
-#ifndef __DragonFly__
 static void re_set_wol_linkspeed 	__P((struct re_softc *));
 
+#ifndef __DragonFly__
 static void re_start				__P((struct ifnet *));
 static int re_encap				__P((struct re_softc *, struct mbuf *));
 static void WritePacket				__P((struct re_softc *, caddr_t, int, int, int, uint32_t, uint32_t));
@@ -264,8 +269,8 @@ static void set_rxbufsize(struct re_softc*);
 static void re_release_rx_buf(struct re_softc *);
 static void re_release_tx_buf(struct re_softc *);
 #endif	/* !__DragonFly__ */
-static u_int32_t re_eri_read(struct re_softc *, int , int , int);
-static int re_eri_write(struct re_softc *, int , int , u_int32_t, int);
+static u_int32_t re_eri_read(struct re_softc *, int, int, int);
+static int re_eri_write(struct re_softc *, int, int, u_int32_t, int);
 static void OOB_mutex_lock(struct re_softc *);
 static void OOB_mutex_unlock(struct re_softc *);
 
@@ -281,6 +286,10 @@ u_int16_t MP_ReadPhyUshort(struct re_softc *, u_int8_t);
 
 u_int32_t MP_ReadPciEConfigSpace(struct re_softc *, u_int16_t);
 void MP_WritePciEConfigSpace(struct re_softc *, u_int16_t, u_int32_t);
+u_int32_t MP_ReadOtherFunPciEConfigSpace(struct re_softc *, u_int8_t,
+    u_int16_t);
+void MP_WriteOtherFunPciEConfigSpace(struct re_softc *, u_int8_t, u_int16_t,
+    u_int32_t);
 
 u_int16_t MP_ReadEPhyUshort(struct re_softc *, u_int8_t);
 void MP_WriteEPhyUshort(struct re_softc *, u_int8_t, u_int16_t);
@@ -310,12 +319,12 @@ TUNABLE_INT("hw.re.phy_mdix_mode", &phy_mdix_mode);
 #ifndef __DragonFly__
 static device_method_t re_methods[] = {
         /* Device interface */
-        DEVMETHOD(device_probe,		re_probe),
-        DEVMETHOD(device_attach,	re_attach),
-        DEVMETHOD(device_detach,	re_detach),
-        DEVMETHOD(device_suspend,   re_suspend),
-        DEVMETHOD(device_resume,    re_resume),
-        DEVMETHOD(device_shutdown,	re_shutdown),
+        DEVMETHOD(device_probe, re_probe),
+        DEVMETHOD(device_attach, re_attach),
+        DEVMETHOD(device_detach, re_detach),
+        DEVMETHOD(device_suspend, re_suspend),
+        DEVMETHOD(device_resume, re_resume),
+        DEVMETHOD(device_shutdown, re_shutdown),
         { 0, 0 }
 };
 
@@ -414,6 +423,8 @@ static void re_phy_power_up(device_t dev)
         switch(sc->re_type) {
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 re_wait_phy_ups_resume(sc, 3);
                 break;
         };
@@ -426,6 +437,11 @@ static void re_phy_power_down(device_t dev)
 
         sc = device_get_softc(dev);
 
+        if (sc->re_dash) {
+                re_set_wol_linkspeed(sc);
+                return;
+        }
+
         MP_WritePhyUshort(sc, 0x1F, 0x0000);
 
         switch (sc->re_type) {
@@ -559,10 +575,11 @@ device_t		dev;
 #endif	/* !__DragonFly__ */
 
 
-static u_int32_t re_eri_read(struct re_softc *sc, int addr, int len, int type)
+static u_int32_t re_eri_read_with_oob_base_address(struct re_softc *sc, int addr, int len, int type, const u_int32_t base_address)
 {
         int i, val_shift, shift = 0;
         u_int32_t value1 = 0, value2 = 0, mask;
+        const u_int32_t transformed_base_address = ((base_address & 0x00FFF000) << 6) | (base_address & 0x000FFF);
 
         if (len > 4 || len <= 0)
                 return -1;
@@ -573,6 +590,7 @@ static u_int32_t re_eri_read(struct re_softc *sc, int addr, int len, int type)
 
                 CSR_WRITE_4(sc,RE_ERIAR,
                             ERIAR_Read |
+                            transformed_base_address |
                             type << ERIAR_Type_shift |
                             ERIAR_ByteEn << ERIAR_ByteEn_shift |
                             addr);
@@ -605,11 +623,17 @@ static u_int32_t re_eri_read(struct re_softc *sc, int addr, int len, int type)
         return value2;
 }
 
-static int re_eri_write(struct re_softc *sc, int addr, int len, u_int32_t value, int type)
+static u_int32_t re_eri_read(struct re_softc *sc, int addr, int len, int type)
+{
+        return re_eri_read_with_oob_base_address(sc, addr, len, type, 0);
+}
+
+static int re_eri_write_with_oob_base_address(struct re_softc *sc, int addr, int len, u_int32_t value, int type, const u_int32_t base_address)
 {
 
         int i, val_shift, shift = 0;
         u_int32_t value1 = 0, mask;
+        const u_int32_t transformed_base_address = ((base_address & 0x00FFF000) << 6) | (base_address & 0x000FFF);
 
         if (len > 4 || len <= 0)
                 return -1;
@@ -623,12 +647,13 @@ static int re_eri_write(struct re_softc *sc, int addr, int len, u_int32_t value,
                 else if (len == 3)	mask = (0xFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
                 else			mask = (0xFFFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
 
-                value1 = re_eri_read(sc, addr, 4, type) & ~mask;
+                value1 = re_eri_read_with_oob_base_address(sc, addr, 4, type, base_address) & ~mask;
                 value1 |= ((value << val_shift * 8) >> shift * 8);
 
                 CSR_WRITE_4(sc,RE_ERIDR, value1);
                 CSR_WRITE_4(sc,RE_ERIAR,
                             ERIAR_Write |
+                            transformed_base_address |
                             type << ERIAR_Type_shift |
                             ERIAR_ByteEn << ERIAR_ByteEn_shift |
                             addr);
@@ -653,6 +678,11 @@ static int re_eri_write(struct re_softc *sc, int addr, int len, u_int32_t value,
         return 0;
 }
 
+static int re_eri_write(struct re_softc *sc, int addr, int len, u_int32_t value, int type)
+{
+        return re_eri_write_with_oob_base_address(sc, addr, len, value, type, 0);
+}
+
 static void
 ClearAndSetEthPhyBit(
         struct re_softc *sc,
@@ -848,9 +878,28 @@ static void set_rxbufsize(struct re_softc *sc)
 }
 #endif	/* !__DragonFly__ */
 
+static void re_enable_cfg9346_write(struct re_softc *sc)
+{
+        EE_SET(RE_EEMODE_WRITECFG);
+}
+
+static void re_disable_cfg9346_write(struct re_softc *sc)
+{
+        EE_CLR(RE_EEMODE_WRITECFG);
+}
+
 static void DisableMcuBPs(struct re_softc *sc)
 {
         switch(sc->re_type) {
+        case MACFG_68:
+        case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
+                MP_WriteMcuAccessRegWord(sc, 0xFC38, 0x0000);
+                break;
+        }
+
+        switch(sc->re_type) {
         case MACFG_56:
         case MACFG_57:
         case MACFG_58:
@@ -861,10 +910,12 @@ static void DisableMcuBPs(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
-                CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_WRITECFG);
+        case MACFG_70:
+        case MACFG_71:
+                re_enable_cfg9346_write(sc);
                 CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) & ~BIT_0);
                 CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) & ~BIT_7);
-                CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+                re_disable_cfg9346_write(sc);
 
                 MP_WriteMcuAccessRegWord(sc, 0xFC28, 0x0000);
                 MP_WriteMcuAccessRegWord(sc, 0xFC2A, 0x0000);
